"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var _this = this;
Object.defineProperty(exports, "__esModule", { value: true });
var fs = require("fs");
var os = require("os");
var CDP = require("chrome-remote-interface");
var ava_1 = require("ava");
var src_1 = require("../src");
var testHtml = fs.readFileSync('./src/__tests__/test.html');
var testUrl = "data:text/html," + testHtml;
var getPngMetaData = function (filePath) { return __awaiter(_this, void 0, void 0, function () {
    var fd;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                fd = fs.openSync(filePath, 'r');
                return [4 /*yield*/, new Promise(function (resolve) {
                        fs.read(fd, Buffer.alloc(24), 0, 24, 0, function (err, bytesRead, buffer) {
                            return resolve({
                                width: buffer.readUInt32BE(16),
                                height: buffer.readUInt32BE(20),
                            });
                        });
                    })];
            case 1: return [2 /*return*/, _a.sent()];
        }
    });
}); };
// POC
ava_1.default('evaluate (document.title)', function (t) { return __awaiter(_this, void 0, void 0, function () {
    var chromeless, title;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                chromeless = new src_1.default({ launchChrome: false });
                return [4 /*yield*/, chromeless.goto(testUrl).evaluate(function () { return document.title; })];
            case 1:
                title = _a.sent();
                return [4 /*yield*/, chromeless.end()];
            case 2:
                _a.sent();
                t.is(title, 'Title');
                return [2 /*return*/];
        }
    });
}); });
ava_1.default('screenshot and pdf path', function (t) { return __awaiter(_this, void 0, void 0, function () {
    var chromeless, screenshot, pdf, regex;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                chromeless = new src_1.default({ launchChrome: false });
                return [4 /*yield*/, chromeless.goto(testUrl).screenshot()];
            case 1:
                screenshot = _a.sent();
                return [4 /*yield*/, chromeless.goto(testUrl).pdf()];
            case 2:
                pdf = _a.sent();
                return [4 /*yield*/, chromeless.end()];
            case 3:
                _a.sent();
                regex = new RegExp(os.tmpdir().replace(/\\/g, '\\\\'));
                t.regex(screenshot, regex);
                t.regex(pdf, regex);
                return [2 /*return*/];
        }
    });
}); });
ava_1.default('screenshot by selector', function (t) { return __awaiter(_this, void 0, void 0, function () {
    var version, versionMajor, chromeless, screenshot, png;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, CDP.Version()];
            case 1:
                version = _a.sent();
                versionMajor = parseInt(/Chrome\/(\d+)/.exec(version['User-Agent'])[1]);
                chromeless = new src_1.default({ launchChrome: false });
                return [4 /*yield*/, chromeless.goto(testUrl).screenshot('img')];
            case 2:
                screenshot = _a.sent();
                return [4 /*yield*/, chromeless.end()];
            case 3:
                _a.sent();
                return [4 /*yield*/, getPngMetaData(screenshot)];
            case 4:
                png = _a.sent();
                t.is(png.width, versionMajor > 60 ? 512 : 1440);
                t.is(png.height, versionMajor > 60 ? 512 : 900);
                return [2 /*return*/];
        }
    });
}); });
//# sourceMappingURL=util.test.js.map